build.sh 3.5 KB

1234567891011121314151617181920212223242526272829303132333435363738394041424344454647484950515253545556575859606162636465666768697071727374757677
  1. #!/bin/bash
  2. cd $(dirname $0)
  3. REVISION_NO=`git rev-list --count HEAD`
  4. # check preconditions
  5. if [ -z "${JAVA_HOME}" ]; then echo "JAVA_HOME not set. Run using JAVA_HOME=/path/to/jdk ./build.sh"; exit 1; fi
  6. command -v mvn >/dev/null 2>&1 || { echo >&2 "mvn not found."; exit 1; }
  7. command -v curl >/dev/null 2>&1 || { echo >&2 "curl not found."; exit 1; }
  8. VERSION=$(mvn -f ../../../pom.xml help:evaluate -Dexpression=project.version -q -DforceStdout)
  9. # compile
  10. mvn -B -f ../../../pom.xml clean package -DskipTests -Plinux
  11. cp ../../../target/cryptomator-*.jar ../../../target/mods
  12. # add runtime
  13. ${JAVA_HOME}/bin/jlink \
  14. --output runtime \
  15. --module-path "${JAVA_HOME}/jmods" \
  16. --add-modules java.base,java.desktop,java.logging,java.naming,java.net.http,java.scripting,java.sql,java.xml,jdk.unsupported,jdk.crypto.ec,jdk.accessibility \
  17. --no-header-files \
  18. --no-man-pages \
  19. --strip-debug \
  20. --compress=1
  21. # create app dir
  22. ${JAVA_HOME}/bin/jpackage \
  23. --verbose \
  24. --type app-image \
  25. --runtime-image runtime \
  26. --input ../../../target/libs \
  27. --module-path ../../../target/mods \
  28. --module org.cryptomator.desktop/org.cryptomator.launcher.Cryptomator \
  29. --dest . \
  30. --name Cryptomator \
  31. --vendor "Skymatic GmbH" \
  32. --copyright "(C) 2016 - 2021 Skymatic GmbH" \
  33. --java-options "-Xss5m" \
  34. --java-options "-Xmx256m" \
  35. --app-version "${VERSION}.${REVISION_NO}" \
  36. --java-options "-Dfile.encoding=\"utf-8\"" \
  37. --java-options "-Dcryptomator.logDir=\"~/.local/share/Cryptomator/logs\"" \
  38. --java-options "-Dcryptomator.pluginDir=\"~/.local/share/Cryptomator/plugins\"" \
  39. --java-options "-Dcryptomator.settingsPath=\"~/.config/Cryptomator/settings.json:~/.Cryptomator/settings.json\"" \
  40. --java-options "-Dcryptomator.ipcSocketPath=\"~/.config/Cryptomator/ipc.socket\"" \
  41. --java-options "-Dcryptomator.mountPointsDir=\"~/.local/share/Cryptomator/mnt\"" \
  42. --java-options "-Dcryptomator.showTrayIcon=false" \
  43. --java-options "-Dcryptomator.buildNumber=\"appimage-${REVISION_NO}\"" \
  44. --resource-dir ../resources
  45. # transform AppDir
  46. mv Cryptomator Cryptomator.AppDir
  47. cp -r resources/AppDir/* Cryptomator.AppDir/
  48. chmod +x Cryptomator.AppDir/lib/runtime/bin/java
  49. envsubst '${REVISION_NO}' < resources/AppDir/bin/cryptomator.sh > Cryptomator.AppDir/bin/cryptomator.sh
  50. ln -s usr/share/icons/hicolor/scalable/apps/org.cryptomator.Cryptomator.svg Cryptomator.AppDir/org.cryptomator.Cryptomator.svg
  51. ln -s usr/share/icons/hicolor/scalable/apps/org.cryptomator.Cryptomator.svg Cryptomator.AppDir/Cryptomator.svg
  52. ln -s usr/share/icons/hicolor/scalable/apps/org.cryptomator.Cryptomator.svg Cryptomator.AppDir/.DirIcon
  53. ln -s usr/share/applications/org.cryptomator.Cryptomator.desktop Cryptomator.AppDir/Cryptomator.desktop
  54. ln -s bin/cryptomator.sh Cryptomator.AppDir/AppRun
  55. # extract jffi
  56. JFFI_NATIVE_JAR=`ls Cryptomator.AppDir/lib/app | grep -e 'jffi-[1-9]\.[0-9]\{1,2\}.[0-9]\{1,2\}-native.jar'`
  57. ${JAVA_HOME}/bin/jar -xf Cryptomator.AppDir/lib/app/${JFFI_NATIVE_JAR} /jni/x86_64-Linux/
  58. mv jni/x86_64-Linux/* Cryptomator.AppDir/lib/app/libjffi.so
  59. rm -r jni/x86_64-Linux
  60. # load AppImageTool
  61. curl -L https://github.com/AppImage/AppImageKit/releases/download/13/appimagetool-x86_64.AppImage -o /tmp/appimagetool.AppImage
  62. chmod +x /tmp/appimagetool.AppImage
  63. # create AppImage
  64. /tmp/appimagetool.AppImage \
  65. Cryptomator.AppDir \
  66. cryptomator-SNAPSHOT-x86_64.AppImage \
  67. -u 'gh-releases-zsync|cryptomator|cryptomator|latest|cryptomator-*-x86_64.AppImage.zsync'